/* 

  wn.c - Command line interface to WordNet

*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "wn.h"
#include "wnhelp.h"
#include "license.h"

int compare(char *word1, char *word2)
{
    int i, j = 1, pos, matches, l1 = 0, l2 = 0;
    int whichsense = ALLSENSES, help = 0;
    char *mword=(char *)malloc(sizeof(char)*20);
    SynsetPtr found1, found2, cur1, cur2, curss;

    if (wninit()) {	/* open database */
	printf("wn: Fatal error - cannot open WordNet database\n");
	exit (-1);
    }
    //   ,    
    for (pos=1; pos <= NUMPARTS; pos++) {
        if (pos == 1)  // it's a noun
                found1 = findtheinfo_ds(word1, pos, -HYPERPTR, ALLSENSES);
        else
                found1 = findtheinfo_ds(word1, pos, OVERVIEW, ALLSENSES);
        if (found1 == NULL) // try to morph
             {
                mword = morphword(word1, NOUN);
                //printf("%s => %s\n", searchword, mword);
                if (mword != NULL)
                   if (pos == 1)  // it's a noun
                        found1 = findtheinfo_ds(word1, pos, -HYPERPTR, ALLSENSES);
                   else
                        found1 = findtheinfo_ds(word1, pos, OVERVIEW, ALLSENSES);
             }
        if (pos == 1)  // it's a noun
                found2 = findtheinfo_ds(word2, pos, -HYPERPTR, ALLSENSES);
            else
                found2 = findtheinfo_ds(word2, pos, OVERVIEW, ALLSENSES);
            if (found2 == NULL) // try to morph
             {
                mword = morphword(word2, NOUN);
                //printf("%s => %s\n", searchword, mword);
                if (mword != NULL)
                  if (pos == 1)  // it's a noun
                       found2 = findtheinfo_ds(word2, pos, -HYPERPTR, ALLSENSES);
                  else
                       found2 = findtheinfo_ds(word2, pos, OVERVIEW, ALLSENSES);
        }
        matches=0;
        if ((found1 != NULL) && (found2 != NULL)) {
               cur1 = found1;
               do {
                 cur2 = found2;
                 curss = found2;
                 do {
                   if (cur1->hereiam == cur2->hereiam) {
                      matches += 1/(l1+l2);
                      printf("%D = { %s } level: %i, %i\n", cur1->hereiam, cur1->defn, l1, l2);
                   }
                   if (cur2->ptrlist == NULL) {
                         cur2 = curss->nextss;
                         curss = curss->nextss;
                         l2 = 0;
                      }
                   else {
                         cur2 = cur2->ptrlist;
                         l2++;
                        }
                 } while (cur2 != NULL);
                 if (cur1->ptrlist == NULL) {
                         cur1 = cur1->nextss;
                         l1 = 0;
                      }
                   else {
                         cur1 = cur1->ptrlist;
                         l1++;
                        }
               } while (cur1 != NULL);
         }
        else {
              matches=0;
        }
    }  /* end for */
    free(mword);
    return(matches);
}



