/* 

  wn.c - Command line interface to WordNet

*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "wn.h"
#include "wnhelp.h"
#include "license.h"

void main()
{
    int i, j = 1, pos, matches, l1 = 0, l2 = 0;
    int whichsense = ALLSENSES, help = 0;
    char *word1=(char *)malloc(20),
         *word2=(char *)malloc(20),
         *mword=(char *)malloc(20);
    SynsetPtr found1, found2, cur1, cur2;

    if (wninit()) {	/* open database */
	printf("wn: Fatal error - cannot open WordNet database\n");
	exit (-1);
    }
    while (1) {
       printf("Word 1: \n");
       gets(word1);
       printf("Word 2: \n");
       gets(word2);
       //   ,    
       for (pos=1; pos <= NUMPARTS; pos++) {
           if (pos == 1)  // it's a noun
                found1 = findtheinfo_ds(word1, pos, -HYPERPTR, ALLSENSES);
           else
                found1 = findtheinfo_ds(word1, pos, OVERVIEW, ALLSENSES);
           if (found1 == NULL) // try to morph
             {
                mword = morphword(word1, NOUN);
                //printf("%s => %s\n", searchword, mword);
                if (mword != NULL)
                   if (pos == 1)  // it's a noun
                        found1 = findtheinfo_ds(word1, pos, -HYPERPTR, ALLSENSES);
                   else
                        found1 = findtheinfo_ds(word1, pos, OVERVIEW, ALLSENSES);
             }
            if (pos == 1)  // it's a noun
                found2 = findtheinfo_ds(word2, pos, -HYPERPTR, ALLSENSES);
            else
                found2 = findtheinfo_ds(word2, pos, OVERVIEW, ALLSENSES);
            if (found2 == NULL) // try to morph
             {
                mword = morphword(word2, NOUN);
                //printf("%s => %s\n", searchword, mword);
                if (mword != NULL)
                  if (pos == 1)  // it's a noun
                       found2 = findtheinfo_ds(word2, pos, -HYPERPTR, ALLSENSES);
                  else
                       found2 = findtheinfo_ds(word2, pos, OVERVIEW, ALLSENSES);
             }
           matches=0;
           if ((found1 != NULL) && (found2 != NULL)) {
               cur1 = found1;
               do {
                 cur2 = found2;
                 do {
                   if (cur1->hereiam == cur2->hereiam) {
                      matches++;
                      printf("%D = { %s } level: %i, %i\n", cur1->hereiam, cur1->defn, l1, l2);
                   }
                   if (cur2->ptrlist == NULL) {
                         cur2 = cur2->nextss;
                         l2 = 0;
                      }
                   else {
                         cur2 = cur2->ptrlist;
                         l2++;
                        }
                 } while (cur2 != NULL);
                 if (cur1->ptrlist == NULL) {
                         cur1 = cur1->nextss;
                         l1 = 0;
                      }
                   else {
                         cur1 = cur1->ptrlist;
                         l1++;
                        }
               } while (cur1 != NULL);
           }
           else {
              printf("no match found\n");          
           }
           printf("matches: %i \n", matches);
           printf("-------------\n");
       }  /* end for */
      printf("=====================\n");
    }
    free(mword);
    free(word1);
    free(word2);
}



