/*********************************************************
 * Question parser                                       *
 *********************************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "wn.h"
#include "wnhelp.h"
#include "license.h"


struct WRD {
        char *w;
        struct WRD *next, *prior;
      };

struct TQuestion {
    WRD *head, *tail, *cur;
  public:
    void addword(char *wrd);
    void addsentense(char *sentense);
    char *getword() {return cur->w;};
    WRD *ff() {cur = cur->next; return cur;};
    void rewind() {cur = head; };
    TQuestion()
     {
        head = tail = cur = NULL;
        head->prior = NULL;
        tail->next = NULL;
     };
     TQuestion(char *sentense)
     {
        addsentense(sentense);
     };
     ~TQuestion()
     {  while (tail != NULL) {
           delete(tail->w);
           tail = tail->prior;
           delete(tail->next);
        }
     };
};

void TQuestion::addword(char *wrd)
{
   WRD *temp;

   temp = new(WRD);
   temp->w = new(char[strlen(wrd)]);
   strcpy(temp->w, wrd);
   tail->next = temp;
   temp->prior = tail;
   temp->next = NULL;
   tail = temp;
   if (head == NULL) { head = tail;
                       cur = tail;}
}
  
void TQuestion::addsentense(char *sentense)
{
  int i = -1, wb = 0, we = 0;
  char *word;
  do {
       i++;
       switch (*(sentense+i)) {
         case ' ' : case '\0' :
         case '.' : case ',' :
         case ';' : case ':' :
         case '(' : case ')' :
         case '!' : case '?' :
         case '-' : if (we - wb == 0 ) { wb = i+1; we = i+1;}
                    else {
                            word = new(char[we-wb+2]);
                            memcpy(word, sentense+wb, we-wb+1);
                            word[we-wb+1]='\0';
                            addword(word);
                            delete(word);
                            wb = i+1;
                            we = i+1;
                         };
                    break;
         default: we = i;
                  break;
       }
  } while (*(sentense+i) != '\0');
}


int compare(char *word1, char *word2)
{
    int i, j = 1, pos, matches, l1 = 0, l2 = 0;
    int whichsense = ALLSENSES, help = 0;
    char *mword=(char *)malloc(sizeof(char)*20);
    SynsetPtr found1, found2, cur1, cur2, curss;

    if (wninit()) {	/* open database */
	printf("wn: Fatal error - cannot open WordNet database\n");
	exit (-1);
    }
    //   ,    
    for (pos=1; pos <= NUMPARTS; pos++) {
        if (pos == 1)  // it's a noun
                found1 = findtheinfo_ds(word1, pos, -HYPERPTR, ALLSENSES);
        else
                found1 = findtheinfo_ds(word1, pos, OVERVIEW, ALLSENSES);
        if (found1 == NULL) // try to morph
             {
                mword = morphword(word1, NOUN);
                //printf("%s => %s\n", searchword, mword);
                if (mword != NULL)
                   if (pos == 1)  // it's a noun
                        found1 = findtheinfo_ds(word1, pos, -HYPERPTR, ALLSENSES);
                   else
                        found1 = findtheinfo_ds(word1, pos, OVERVIEW, ALLSENSES);
             }
        if (pos == 1)  // it's a noun
                found2 = findtheinfo_ds(word2, pos, -HYPERPTR, ALLSENSES);
            else
                found2 = findtheinfo_ds(word2, pos, OVERVIEW, ALLSENSES);
            if (found2 == NULL) // try to morph
             {
                mword = morphword(word2, NOUN);
                //printf("%s => %s\n", searchword, mword);
                if (mword != NULL)
                  if (pos == 1)  // it's a noun
                       found2 = findtheinfo_ds(word2, pos, -HYPERPTR, ALLSENSES);
                  else
                       found2 = findtheinfo_ds(word2, pos, OVERVIEW, ALLSENSES);
        }
        matches=0;
        if ((found1 != NULL) && (found2 != NULL)) {
               cur1 = found1;
               do {
                 cur2 = found2;
                 curss = found2;
                 do {
                   if (cur1->hereiam == cur2->hereiam) {
                      matches += 1/(l1+l2);
                      printf("%D = { %s } level: %i, %i\n", cur1->hereiam, cur1->defn, l1, l2);
                   }
                   if (cur2->ptrlist == NULL) {
                         cur2 = curss->nextss;
                         curss = curss->nextss;
                         l2 = 0;
                      }
                   else {
                         cur2 = cur2->ptrlist;
                         l2++;
                        }
                 } while (cur2 != NULL);
                 if (cur1->ptrlist == NULL) {
                         cur1 = cur1->nextss;
                         l1 = 0;
                      }
                   else {
                         cur1 = cur1->ptrlist;
                         l1++;
                        }
               } while (cur1 != NULL);
         }
        else {
              matches=0;
        }
    }  /* end for */
    free(mword);
    return(matches);
};



int main()
{
   TQuestion quest, questfa;
   quest.addsentense("vessel");
   questfa.addsentense("watercraft vehicle entity");
   printf("\n------------------------\n");
   quest.rewind();
   do {
        printf("%s \n", quest.getword());
   } while (quest.ff() != NULL);
   quest.rewind();
   printf("\n------------------------\n");
   questfa.rewind();
   do {
        printf("%s \n", questfa.getword());
   } while (questfa.ff() != NULL);
   questfa.rewind();
   
   do {
      do {
        printf("Compare: %s and %s\n", quest.getword(), questfa.getword());
      } while (questfa.ff() != NULL);
      questfa.rewind();
   } while (quest.ff() != NULL);

   printf("----------  FIN -----------------\n");
   return 0;
}

