/*********************************************************
 * Question parser                                       *
 *********************************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "wn.h"
#include "wnhelp.h"
#include "license.h"


struct WRD {
        char *w;
        struct WRD *next, *prior;
      };

struct TQuestion {
    WRD *head, *tail, *cur;
  public:
    void addword(char *wrd);
    void addsentense(char *sentense);
    char *getword() {return cur->w;};
    WRD *ff() {cur = cur->next; return cur;};
    void rewind() {cur = head; };
    void clear() {
        while (tail != NULL) {
           delete(tail->w);
           if (tail->prior != NULL) {
                          tail = tail->prior;
                          delete(tail->next);
           }
           else { delete(tail); tail = NULL; };
        }
        head = tail = cur = NULL;
        head->prior = NULL;
        tail->next = NULL;
     };
    TQuestion()
     {
        head = tail = cur = NULL;
        head->prior = NULL;
        tail->next = NULL;
     };
     TQuestion(char *sentense)
     {
        head = tail = cur = NULL;
        head->prior = NULL;
        tail->next = NULL;
        addsentense(sentense);
     };
     ~TQuestion()
     {  while (tail != NULL) {
           delete(tail->w);
           if (tail->prior != NULL) {
                          tail = tail->prior;
                          delete(tail->next);
           }
           else { delete(tail); tail = NULL; };
        }
     };
};

void TQuestion::addword(char *wrd)
{
   WRD *temp;

   temp = new(WRD);
   temp->w = new(char[strlen(wrd)+1]);
   strcpy(temp->w, wrd);
   temp->w[strlen(wrd)] = '\0';
   tail->next = temp;
   temp->prior = tail;
   temp->next = NULL;
   tail = temp;
   if (head == NULL) { head = tail;
                       cur = tail;}
}
  
void TQuestion::addsentense(char *sentense)
{
  int i = -1, wb = 0, we = 0;
  char *word;
  do {
       i++;
       switch (*(sentense+i)) {
         case ' ' : case '\0' : case '\n' :
         case '.' : case ',' :
         case ';' : case ':' :
         case '(' : case ')' :
         case '!' : case '?' :
         case '-' : if (we - wb == 0 ) { wb = i+1; we = i+1;}
                    else {
                            if (we-wb > 2)
                              {
                                 word = new(char[we-wb+2]);
                                 memcpy(word, sentense+wb, we-wb+1);
                                 word[we-wb+1]='\0';
                                 addword(word);
                                 delete(word);
                              }
                            wb = i+1;
                            we = i+1;
                         };
                    break;
         default: we = i;
                  break;
       }
  } while (*(sentense+i) != '\0');
}


double compare(char *word1, char *word2)
{
    int i, j = 1, pos, l1 = 0, l2 = 0, mf = 0;
    double matches=0;
    int whichsense = ALLSENSES, help = 0;
    char *mword;
    SynsetPtr found1, found2, cur1, cur2, curss1, curss2;

//printf("\n in compare \n");
    //   ,    
    for (pos=1; pos <= NUMPARTS; pos++) {
        if (pos == 1)  // it's a noun
                found1 = findtheinfo_ds(word1, pos, -HYPERPTR, ALLSENSES);
        else
                found1 = findtheinfo_ds(word1, pos, OVERVIEW, ALLSENSES);
        if (found1 == NULL) // try to morph
             {
                mword = morphword(word1, NOUN);
  //              printf("w1: %s => %s\n", word1, mword);
                if (mword != NULL)
                   if (pos == 1)  // it's a noun
                        found1 = findtheinfo_ds(mword, pos, -HYPERPTR, ALLSENSES);
                   else
                        found1 = findtheinfo_ds(mword, pos, OVERVIEW, ALLSENSES);
             }
        if (pos == 1)  // it's a noun
                found2 = findtheinfo_ds(word2, pos, -HYPERPTR, ALLSENSES);
            else
                found2 = findtheinfo_ds(word2, pos, OVERVIEW, ALLSENSES);
            if (found2 == NULL) // try to morph
             {
                mword = morphword(word2, NOUN);
  //              printf("w2: %s => %s\n", word2, mword);
                if (mword != NULL)
                  if (pos == 1)  // it's a noun
                       found2 = findtheinfo_ds(mword, pos, -HYPERPTR, ALLSENSES);
                  else
                       found2 = findtheinfo_ds(mword, pos, OVERVIEW, ALLSENSES);
        }
        if ((found1 != NULL) && (found2 != NULL)) {
               cur1 = found1;
               curss1 = found1;
               do {
                 cur2 = found2;
                 curss2 = found2;
                 do {
                   printf("debug: %D = { %s } level: %i\n", cur1->hereiam, cur1->defn, l1);
                   printf("       %D = { %s } level: %i\n", cur2->hereiam, cur2->defn, l2);
                   if (cur1->hereiam == cur2->hereiam) {
                      if ((l1 == 0) && (l2 == 0)) { matches += 1.0; }
                      else { matches += 1.0/(l1+l2); }
   //                   printf("%D = { %s } level: %i, %i\n", cur1->hereiam, cur1->defn, l1, l2);
                      mf = 1;
                      l2 = 0;
                      break;
                   }
                   if (cur2->ptrlist == NULL) {
                         cur2 = curss2->nextss;
                         curss2 = curss2->nextss;
                         l2 = 0;
                      }
                   else {
                         cur2 = cur2->ptrlist;
                         l2++;
                        }
                 } while (cur2 != NULL);
                 if ((cur1->ptrlist == NULL) || (mf == 1)) {
                         cur1 = curss1->nextss;
                         curss1 = curss1->nextss;
                         l1 = 0;
                         mf = 0;
                      }
                   else {
                         cur1 = cur1->ptrlist;
                         l1++;
                        }
               } while (cur1 != NULL);
               free_syns(found1);
               free_syns(found2);
         }
        else {
           if (found1 != NULL) free_syns(found1);
           if (found2 != NULL) free_syns(found2);
              // matches=0;
        }
    }  /* end for */
    return(matches);
};



double score(TQuestion *quest, TQuestion *questfa)
{
   double totalscore = 0.0, wordscore = 0.0, score;
   
   quest->rewind();
   questfa->rewind();
   
   do {
      do {
        printf("-----------\nCompare: %s and %s.\n", quest->getword(),
                                                   questfa->getword());
        score = compare(quest->getword(),questfa->getword());
        if (score > wordscore) { wordscore = score; }
        printf("Score: %e \n", score);
      } while (questfa->ff() != NULL);
      totalscore += wordscore;
      wordscore = 0;
      questfa->rewind();
   } while (quest->ff() != NULL);
//   printf("\n Question score: %f\n", totalscore);
//   printf("----------  FIN -----------------\n");
   return(totalscore);
}

int main()
{
   char qfaq[80], quest[80];
   TQuestion *q1 = new(TQuestion), *q2 = new(TQuestion);
   FILE *inFAQ, *inQuests;
   inFAQ = fopen("faq.txt", "r");
   inQuests = fopen("qst.txt", "r");
   if ((inFAQ == NULL) || (inQuests == NULL)) {
       printf("\n Error open files! \n");
       exit(1);
   }
   if (wninit()) {   /* open database */
       printf("wn: Fatal error - cannot open WordNet database\n");
       exit (-1);
    }
   while (fgets(quest, 80, inQuests)) // Questions Loop
   {
      printf("\n============================= \n");
      printf("Q: %s \n", quest);
      q1->addsentense(quest);
      while (fgets(qfaq, 80, inFAQ))  // FAQ questions Loop
      {
         q2->addsentense(qfaq);
         printf("   FAQ: %s   Question score: %f\n",
                 qfaq, score(q1, q2));
         q2->clear();
      }
      q1->clear();
      fseek(inFAQ, 0, SEEK_SET);
   }
   printf("\n============================= \n");
   fclose(inFAQ);
   fclose(inQuests);
   delete(q1);
   delete(q2);
   return 0;
}

